Braindump sp2 07/2003

1. Allgemeine Fragen zu Datenbanken.
	- Warum verwendet man Datenbanken?
	- 5 Sachen die Datenbank besser machen als normales Dateisystem.

	(Richtig oder Falsch):
	- Eine Datenbank macht nur bei groen Datenmengen Sinn?
	- Eine DB kann mehr Daten sortieren, als in den Hauptspeicher passen?

2. Datenstrukturen:
	- Hashing-Verfahren. Eifgen in Buckets mit berlaufbuckets.
	- Einfuegen im B-Baum:
		Fgen sie die Zahlen 1, 4, 3, 6, 5, 7, 8 in einen leeren B-Baum
		mit k = 1 ein. Zeigen Sie alle Zwischenschritte. Zur Vereinfachung
		darf angenommen werden, da alle Daten die gleiche Gre besitzen.
		Benutzen Sie die folgende Schreibweise fr die Knoten:

		+---+---+---+
		| 4 |[|]| o |
		+---+---+---+
		  ^   ^   ^
		  |   |   &nbspZeiger
		  |   &nbspDaten
		   &nbspSchlssel

	- Einfuegen im nichtleeren B*-Baum
	- 2 Unterschiede von B-Baum und B*-Baum.

3. E/R-Diagramme:
	- aus Text eins erstellen
	- Kardinalitaeten einfuegen in Diagramm mit x = {2,8}, y = {1,..,9}
	und Funktionen x < y, x >= y, x mod y = 0

4. Vergleich TID, DBTT, berlaufbehandlung

5. ?

6. SQL-Teil
	- Vier Abfragen auf einen Tabellensatz (Person, Station, StationaererAufenthalt)
	- Ein Statement auswerten:

	SELECT N, sum(T) AS SUMME
	FROM RA r1 LEFT OUTER JOIN RB r2 ON r1.M = r2.R
	GROUP BY N
	ORDER BY SUMME ASC
	
	RA:
	L	M
	1	5
	6	4
	4	3
	2	2
	3	5
	5	3
	
	RB:
	N	R	T
	1	5	3
	2	2	2
	4	3	2
	1	5	2
	1	5	1
	2	3	1
	4	2	4

7. Ersetzungsstrategien
	- FIFO und  LRU anwenden
	- zwei weitere Strategien nennen (LFU, Radom)
	- Operationen eines Systempuffers erklaeren (fix, unfix, etc)

8. Transaktionen:
	Gegenseitige Beeinflussung, Fehlervermeidung, Zugsriffssteuerung (Serialisierung),
	Einbringstrategien

9. Im algemeinen sehr umfangreicher Teil fr 26 Punkte:

	- Allgemeine C++ Fragen:
		* 2 Unterschiede von Pointer und Referenz
		* Welche Cast Operationen gibt es und was machen sie.
	- C++ Ausdruecke auswerten (ein grosser Haufen pointer)
	Welche Ausgabe liefert das folgende Programm (begrnden Sie Ihre Antwort kurz):
	#include <iostream>

	int main() {

		float x = 8.0f;
		float& y = x;
		float z = x;
		y = 9.81f;

		std::cout << "x: " << x << ", y: " << y << ", z: " << z << std::endl;

		return 0;
	}

	Welche Ausgabe liefert das folgende Programm und begrnden Sie Ihre Antwort kurz:
	void exchange1( int& a, int& b ) {
		int h = a;
		a = b;
		b = h;
	}

	void exchange2( int* a, int* b ) {
		int* h = a;
		a = b;
		b = h;
	}

	#include <iostream>

	int main() {
	
		int x = 4;
		int y = 5;
		int& a = x;
		int& b = y;
	
		exchange1( a, b );
		std::cout << "x: " << x << ", y: " << y << std::endl;
	
		exchange2( &a, &b );
		std::cout << "x: " << x << ", y: " << y << std::endl;
	
	
		return 0;
	}

	- C++ Klasse Mehrwertsteuer mit Funktion tax() (Exception Handling).
		Schreiben Sie eine Klasse MehrwertSteuer. Sie soll eine ffentliche
		Methode float tax( float NettoPreis, float Steuersatz ) besitzen,
		die den Bruttopreis als Produkt aus Nettopreis und Steuersatz
		berechnet. Ist der Steuersatz kleiner als 1, soll eine taxInvalidArgument
		(hie anders, aber mein Hirn kommt net drauf) Exception geworfen werden.
		Schreiben Sie zustzlich ein Hauptprogramm, das den Bruttopreis fr
		100 bei einem Steuersatz 1.16 auf stdout ausgibt.

	- Ein Stacktemplate bauen 
	- Brueche implementieren
	- Klassenhierarchie aufbauen

Fazit: Sehr lang; d.h. man kann sich aus den ganzen Aufgaben ein paar 
aussuchen (127 Punkte, 45 zum bestehen, 100 Minuten Zeit) ==> Sehr FAIR

Dank fer die Untersttzung geht an:
Thomas, Tobi, byteman, doc, Mic, Chresch, delta, dart und fl0yd der die vielen Codefragmente beisteuerte.

